/**
 * Created by soutez305 on 24.6.2017.
 */
function initContacts() {
    if (localStorage.contacts === undefined) {
        localStorage.setItem("contacts", JSON.stringify([]));
        console.log(localStorage);
    }
    displayContacts();

}

function deleteAllContacts() {
    if(confirm("Opravdu chcete smazat všechny kontakty?")) {
        localStorage.contacts = JSON.stringify([]);
        setTimeout(displayContacts(),1000);
    }
    resetMainView();
}

function displayContacts() {
    var data = getContacts();
    if (data.length > 0) {
        var container = $("#contact-list .contacts");
        container.html("");
        data.forEach(function (c) {
            var contactElement = $("<figure></figure>");
            contactElement.addClass("contact")
                .attr("data-id", c.id)
                .html(
                    "<img src='img/icons/vcard.svg'>" +
                    "<figcaption>" +
                    "<span class='name'>" + c.name + " </span>" +
                    "<span class='surname'>"+c.surname+"</span>" +
                    "</figcaption>"
                )
                .click(function(){
                    showDetailView($(this).attr("data-id"))
                });
            container.append(contactElement);
        });
    }
}

function getContacts() {
    return JSON.parse(localStorage.contacts);
}

function addContact() {
    var c = getContacts(),
        i = 0;
    if(i.length > 0) i = c[c.length - 1].id + 1 ;
    c.push({
        id: i,
        name: "Nový",
        surname: "Kontakt",
        tags: [],
        emails: [
            {name: "Email", value: "@"}
        ],
        phones: [
            {name:"Telefon", value: ""}
        ],
        address: {
            street: "Luční 28",
            city: "Liberec",
            psc: "46001"
        }
    });
    localStorage.contacts = JSON.stringify(c);
    displayContacts();
}

function resetMainView(){
    $("#main-view").html(
        "<p>Pokračujte výběrem kontaktu vpravo.</p>"
    );
}

function showDetailView(id) {
    var c = getContacts(),
        kontakt = {};
    c.forEach(function (e) {
        if (e.id == id) {
            kontakt = e;
        }
    });

    $("#main-view").html(
        '<div class="contact-detail"> ' +
        '<header> ' +
        '<h1>' + kontakt.name + ' ' + kontakt.surname + '</h1>' +
        ' <div class="close-detail">' +
        ' <img src="img/icons/close.svg" alt="">' +
        ' </div> ' +
        '</header>' +
        ' <main>' +
        ' <div class="user-image">' +
        '<img src="img/icons/user.svg" alt="">' +
        '<button id="btn-edit-user"><img src="img/icons/edit.svg" alt="">Upravit</button>' +
        '</div>' +
        '<div class="user-info"></div>' +
        '</main>' +
        '</div>'
    );

    detailViewAddInput("Jméno", kontakt.name);
    detailViewAddInput("Příjmení", kontakt.surname);

    kontakt.emails.forEach(function(e){
       detailViewAddInput(e.name, e.value);
    });

    kontakt.phones.forEach(function(e){
        detailViewAddInput(e.name, e.value);
    });

    detailViewAddInput("Adresa", kontakt.address.street + "<br>" + kontakt.address.psc + " " + kontakt.address.city);


    $(".close-detail").click(function(){resetMainView()});
    $("#btn-edit-user").click(function(){showEditView(kontakt.id)})

}

function detailViewAddInput(name, value){
    $("#main-view .user-info").append(
        $("<figure class='udaj'>" +
            "<figcaption>" + name + ":</figcaption>" +
            "<div class='value'>" + value + "</div>" +
            "</figure>")
    );
}

function exportData(){
    alert(localStorage.contacts);
}

function importData(){
    var data = prompt("Zadejte exportovaná data","");
    try{
        JSON.parse(data);
        localStorage.contacts = data;
        displayContacts();
    }
    catch (e){
        alert("Neplatný formát");
    }
}